[general]
* **Remote Configuration Manager:** The Remote Interface is a web based GUI for online administration of i-net Crystal-Clear. It allows you to manage the server configurations from any PC. The Remote Interface can be accessed in the browser using the URL:
  * `http://<servername>:<port>/remote/` or
  * `http://<servername>:<port>/<context>/remote/`
  * By default the Remote Interface is disabled after installation. Before you can use it to configure i-net Crystal-Clear, it is necessary to enable the Remote Interface in the Configuration Manager.
* **Remote Data Source Manager:** There is now a new remote module for configuring and managing a server's data source. This enables you to configure your data source configurations within your browser via an elegant and simple web interface.
* **Report Repository:** Since version 9.1 it is possible to host a Report Repository on a running i-net Crystal-Clear Plus server. Using the module "Repository Browser" of the Remote Interface it is possible to manage and use the content of the configured repository remotely in a browser on a client. Using the Repository Browser in i-net DesignerXML, users have direct access to a configured repository. It is possible to directly open, create and save reports in the repository without using the Remote Repository Browser so that the repository can be used as centralized storage for the reports of multiple designers.
* **System Permissions:** Using the System Permissions it is possible to configure the access the different modules of the Remote Interface, like Repository.

[general:de]
* **Remote Configuration Manager:** Die Remote-Schnittstelle ist eine webbasierte GUI für die Online-Verwaltung von i-net Crystal-Clear. Es ermöglicht Ihnen die Verwaltung der Serverkonfigurationen von jedem beliebigen PC aus. Das Remote Interface kann im Browser über die URL aufgerufen werden:
  * `http://<Servername>:<Port>/remote/` oder
  * `http://<Servername>:<Port>/<Kontext>/remote/`
  * Standardmäßig ist die Remote-Schnittstelle nach der Installation deaktiviert. Bevor Sie sie zur Konfiguration von i-net Crystal-Clear verwenden können, müssen Sie die Remote-Schnittstelle im Konfigurationsmanager aktivieren.
* **Remote Data Source Manager:** Es gibt jetzt ein neues Remote-Modul für die Konfiguration und Verwaltung der Datenquelle eines Servers. Damit können Sie Ihre Datenquellenkonfigurationen über eine elegante und einfache Weboberfläche in Ihrem Browser konfigurieren.
* **Report Repository:** Seit Version 9.1 ist es möglich, ein Report Repository auf einem laufenden i-net Crystal-Clear Plus-Server zu hosten. Mit dem Modul "Repository Browser" des Remote Interface ist es möglich, den Inhalt des konfigurierten Repositorys remote in einem Browser auf einem Client zu verwalten und zu nutzen. Mit dem Repository Browser in i-net DesignerXML haben Benutzer direkten Zugriff auf ein konfiguriertes Repository. Es ist möglich, Berichte direkt im Repository zu öffnen, zu erstellen und zu speichern, ohne den Remote Repository Browser zu verwenden, so dass das Repository als zentraler Speicher für die Berichte mehrerer Designer verwendet werden kann.
* **Systemberechtigungen:** Mit den Systemberechtigungen kann der Zugriff auf die verschiedenen Module der Remote-Schnittstelle, wie z. B. das Repository, konfiguriert werden.

[changes]
* **Modified Behavior of formulas with evaluation time WhileReadingRecords:**
  * All formulas with evaluation time WhileReadingRecords that are used in the report are now executed before the rendering of the first section begins.
  * Variables used in formulas with the WhileReadingRecords evaluation time are not reset before the rendering starts so that the variables can be used in formulas with WhilePrintingRecords evaluation time, also.

Because of this modified behavior it might be necessary to update your reports using the WhileReadingRecords function so that you get the same result as with previous i-net Crystal-Clear versions. It is unfortunately necessary to do this behavior modification because the old behavior was incorrect.

If you use an older configuration with i-net Crystal-Clear version 9, then it is necessary to set the Compatibility Level to "compliant to version 9.x" to use the new behavior of "WhileReadingRecords" formulas. If you create a new configuration with version 9, then "compliant to version 9.x" is the default value.
* **Summary functions reworked:** The summary functions were completely reworked to optimize the performance and compatibility. These are the major impacts of this change:
  * in running total summaries, any database, formula or group field can be used as an evaluate or reset condition
  * in running total summaries, non-boolean formula fields can now be used as an evaluate or reset condition
  * running total summaries now have the same performance impact as non running totals, but they still require more memory
  * it is now always safe to summarize other summary fields
  * non-statistical functions have an initial value of 'null' instead of zero
  * adding one or more 'null' values to a summary will not change it's result
  * correlation and covariance now return 1 if their result is undefined
  * 'Pth Percentile' now has a more precise stepping
  * 'Nth most frequent' now always groups by frequency and orders ascending by value before returning the n-th value.
* **Improved Report File Format:** Starting in version 9, i-net Crystal-Clear uses a zipped file format for the report templates (.rpt), similar to the OpenDocument zip file format. This new report file format was a prerequisite for new features like the Report Preview. With this format the performance has been improved especially for large reports, because the file size is smaller and it is faster. Also, with this format we are open for further additions to the report templates.
* **New export formats: BMP, GIF, JPG and PNG:** With version 9 it is supported to export an individual report page as an image. The following formats are supported: BMP, GIF (with at least Java 6 on the server), JPG and PNG.

With the report URL parameters zoom, width, height and background it is also possible to configure the exported image.
* **New renderer for text interpretation: HTML (advanced):** Fields with Text Interpretation "HTML (advanced)" now use the HTML renderer from i-net software. This fixes many problems which occurred with Swing's HTML renderer which was used before for these fields.
* **Report URL parameters are disallowed by default:** For security reasons, **only** the following parameters are **allowed** by default in the report URL: "prompt", "init" and "sproc". To use other parameters in the report URL, like "datasource", it is necessary to unlock them in the Configuration Manager before using it.

It is always possible to set values for all parameters in the checkProperties method on the server side. Java code samples showing this you can find in the "sample" directory of the documentation (if installed).
* **Underlay Following Sections:** The algorithm for "Underlay Following Sections" was rewritten to implement the correct definition. This can change the output of your reports if you were affected by bugs in the old implementation. One benefit is that you can now design reports with watermarks without any problems. If you want to create a watermark then you only need to add a first section to the report/page header and enable "Underlay Following Sections" for this section. You should place the image either in the report or the page header depending on if you want one watermark per report or one per page.
* **i-net DesignerXML - Default Values:** With version 9.0 it is supported to set default values for the formatting properties used for newly created elements in i-net DesignerXML.

General, font, and border properties can be set for all element types, such as database fields, summary fields, group name fields, and text objects.

Text, paragraph, and value properties can be set depending on the field type, such as String, Number, Currency, Date, Time, DateTime, and Boolean fields.
* **i-net DesignerXML - Report Preview:** A preview of the report will be displayed on the right side of i-net DesignerXML's File Open dialog if the report was executed at least once and saved with version 9.
* **i-net DesignerXML - Signature Element:** With a signature element it is possible to display signature information in the exported PDF file. The signature element is not visible in the Java Viewer or the other export formats. To use the signature element it is necessary to activate and configure the PDF signing in the i-net Crystal-Clear Configuration Manager under "Export –> Sign PDF Files".
* **i-net DesignerXML - Translation Settings / Resource Bundle per report:** The translation settings allows you to create, edit, remove, import, and/or export translations for a report so that it is possible to create one report for multiple languages. The translation resources will be stored in the report file and will be used during the execution of the report. To open it choose "Translations..." from the report menu.
* **i-net DesignerXML - Welcome Page:** The welcome page will be displayed after starting i-net DesignerXML. The available resources are displayed in different regions of this page, so that the user can access it easily.

With the checkbox at the bottom of the welcome page, the user can decide if he will see this page in the future. If it is disabled then he can display it again using the menu item in the Help menu.
* **Step-By-Step Tutorials:** The Step-By-Step Tutorials will guide the user through the steps of doing things in i-net DesignerXML.

The user can access the tutorials in the Welcome Page or in the Help menu.
* **Setup - Improved Selection of Installation Type and Component Selection:** In the first page of the setup the user can decide easily if he will install the i-net DesignerXML or i-net Crystal-Clear as report server. If the user clicks on Server installation then he can select the installation environment on the next page. In the custom installation it is still possible to install both i-net DesignerXML and the report server or servlet in one step.

### i-net Crystal-Clear runtime
* New Remote Configuration Manager for online administration of i-net Crystal-Clear. It allows you to manage the server configurations from any PC.
* **Improved rpt file format.** -  Since version 9 a zipped file format is used for the report templates (.rpt)..
* ReportReaderNet for reports designed with Crystal Reports XI R2 or higher.
* Image export formats added: PNG, JPG, BMP and GIF (Java 6 or higher). 

URL Parameter options are zoom, width, height and background.
* **Start Page added. ** -  It can be accessed with one of the following URLs:
  * `http://<servername>:<port>`  (for Report Servers)
  * `http://<servername>:<port>/<context>`  (for Report Servlets)
* **Report URL parameters deactivated by default.** -  For security reasons, **only** the following report URL parameters are **allowed** by default in the report URL: "prompt", "init" and "sproc". To use other parameters in the report URL, like "datasource", it is necessary to unlock them in the Configuration Manager before using it.
* New API method:
  * Field.duplicate(String) 

Duplicates the Field and returns the created Field with the given name. This method can only be called for copyable fields, i.e. Formula, Prompt, SQL, and Summary Fields. All other fields will throw an UnsupportedOperationException.
  * Cache.getxxxAndWait methods with timeout parameter added.
* New property: For the options "report location" in the report permission settings the option "JNDI location allowed" is now available.
* Fields with Text Interpretation "HTML (advanced)" now use the HTML renderer from i-net software. This fixes many problems which occurred with Swing's HTML renderer which was used before for these fields.
* Hyperlinks on box elements supported.
* New Java Bean added: JGauge. Can be used to display gauge charts in the reports.
* HTML export: The autorefresh feature has now also been implemented for HTML export - using the parameter "autorefresh" will cause the page to be reloaded every x milliseconds, e.g. "autorefresh=10000" for having the page refresh every 10 seconds (build 9.0.130).
* HTML Parameter Request dialog translated depending on the client locale (build 9.0.155).
* On Linux/Unix the file "Listener.sh" added. It can be used to start, stop and restart the report server listener (build 9.0.170).
* Start scripts "startListener.command" and "startConfigurationManager.command" for Mac OS X added (build 9.0.170).
* Incorrect behavior of WhileReadingRecords formulas has changed.
  * All formulas with evaluation time WhileReadingRecords that are used in the report are now executed before the rendering of the first section begins.
  * Variables used in formulas with the WhileReadingRecords evaluation time are not reset before the rendering starts so that the variables can be used in formulas with WhilePrintingRecords evaluation time, also.
* It is no longer supported to use summary functions in WhileReadingRecords formulas. These formulas will be automatically set to WhilePrintingRecords.
* It is now possible to choose how formulas will react on empty database fields.
* Under Windows, the ReportReader tools are now located in the common Program Files folder.
* The configuration properties and their values are now logged in alphabetical order in the log output to make it easier to find a configuration setting.
* Chart:
  * The handling of null values in the continuous charts was changed. The chart ignores now the null values of the category group field.
  * A 'for each record' dataset configuration supports now the color formula, too.
* The report name is proposed in the save dialog of the browser if the report URL parameter "init=<export-format>" is used to export a report. Previously, the server name was proposed.
* Table alias names consisting of digits only will be written with the prefix 'z'.
* Group Selection Formula:
  * Now, filter each record, not only one record per group.
  * Now executed also, if there are no groups in the report.
* As soon as a configuration is changed or a new one is set, i-net Crystal-Clear automatically refreshes its settings. Before, the settings were only refreshed as soon as a report was attempted to be rendered.
* Formula errors which are shown in the report are now prefixed with the string "Formula error:" in order to avoid misunderstandings depending on the formula error message (since build 9.0.130).
* PDF export: EUDC characters will be rendered with the help of EUDC font even if the font of paragraph or field is not an EUDC font. EUDC font must have the name 'EUDC.tte' and must be located in FontPath directory. The font of the paragraph or field must be an embedded font, also (build 9.0.175).

#### API Changes
* Added Constants
  * com.inet.report.Engine
    * EXPORT_BMP
    * EXPORT_GIF
    * EXPORT_JPG
    * EXPORT_PNG
  * com.inet.report.FormulaField
    * TREAT_NULL_AS_NULL
    * TREAT_NULL_BY_DEFAULT
    * TREAT_NULL_BY_EXCEPTION
* Added Methods
  * com.inet.report.Cache
    * getxxxAndWait(xxxx, "int timeout)"
  * com.inet.report.Datasource
    * setDataSourceConfiguration(DataSourceConfiguration)
    * setDataSourceConfigurationName(String)
  * com.inet.report.Engine
    * setDataSourceConfigurationName(String)
  * com.inet.report.Field
    * duplicate(String)
  * com.inet.report.FormulaField
    * checkContext()
    * checkFormula(String, boolean, Engine, Field, Object, int, int)
    * duplicate(String)
    * getNullBehavior()
    * setNullBehavior(int)
  * com.inet.report.Line
    * setHyperlinkUrl="../../String"
    * setHyperlinkUrlFormula(FormulaField)
  * com.inet.report.PromptField
    * duplicate(String)
  * com.inet.report.ReportProperties
    * isCCFormat()
    * getXMLMajorVersion()
    * getXMLMinorVersion()
  * com.inet.report.SummaryInfo
    * getThumbnail()
    * setThumbnail(Image)
  * com.inet.report.SQLField
    * duplicate(String)
  * com.inet.report.SummaryField
    * duplicate(String)
  * com.inet.report.TableSource
    * getDatabaseField(int)
* Methods and Constants deprecated as of Version 9
  * com.inet.report.Datasource
    * setup(String)
    * setup(DataSourceConfiguration)
  * com.inet.report.RDC
    * loadEngine(File, BufferedReader)
    * loadEngine(File, BufferedReader, Properties)
    * Engine loadEngine(File, BufferedReader, String)
    * saveEngine(PrintWriter, Engine)
* Removed Deprecated Methods and Constants
  * com.inet.report.schedule.Scheduler
    * getEmailPassword()
    * setEmailPassword(String)
    * getEmailPop3Host()
    * setEmailPop3Host(String)
    * getEmailSender()
    * setEmailSender(String)
    * getEmailSmtpHost()
    * setEmailSmtpHost(String)
    * getEmailUser()
    * setEmailUser(String)
  * com.inet.report.AbstractLineElement
    * getExtentToBottomOfSectionWhenPrinting()
  * com.inet.report.AbstractValueElement
    * getDateFirstSeperator()
    * setDateFirstSeperator(String)
    * getDateFirstSeperatorFormula()
    * setDateFirstSeperatorFormula(FormulaField)
    * getDatePrefixSeperator()
    * setDatePrefixSeperator(String)
    * getDatePrefixSeperatorFormula()
    * setDatePrefixSeperatorFormula(FormulaField)
    * getDateSecondSeperator()
    * setDateSecondSeperator(String)
    * getDateSecondSeperatorFormula()
    * setDateSecondSeperatorFormula(FormulaField)
    * getDateSuffixSeperator()
    * setDateSuffixSeperator(String)
    * getDateSuffixSeperatorFormula()
    * setDateSuffixSeperatorFormula(FormulaField)
    * getDateTimeSeperator()
    * setDateTimeSeperator(String)
    * getDateTimeSeperatorFormula()
    * setDateTimeSeperatorFormula(FormulaField)
    * getDayOfWeekSeperator()
    * setDayOfWeekSeperator(String)
    * getDayOfWeekSeperatorFormula()
    * setDayOfWeekSeperatorFormula(FormulaField)
    * getDecimalSeperatorsSymbol()
    * setDecimalSeperatorsSymbol(String)
    * getDecimalSeperatorsSymbolFormula()
    * setDecimalSeperatorsSymbolFormula(FormulaField)
    * getHourMinuteSeperator()
    * setHourMinuteSeperator(String)
    * getHourMinuteSeperatorFormula()
    * setHourMinuteSeperatorFormula(FormulaField)
    * getMinuteSecondSeperator()
    * setMinuteSecondSeperator(String)
    * getMinuteSecondSeperatorFormula()
    * setMinuteSecondSeperatorFormula(FormulaField)
    * getThousandSeperatorsSymbol()
    * setThousandSeperatorsSymbol(String)
    * getThousandSeperatorsSymbolFormula()
    * setThousandSeperatorsSymbolFormula(FormulaField)
    * getUseThousandSeperators()
    * setUseThousandSeperators(boolean)
    * getUseThousandSeperatorsFormula()
    * setUseThousandSeperatorsFormula(FormulaField)
  * com.inet.report.BorderProperties
    * getBottomLineStyleFormel()
    * getTopLineStyleFormel()
  * com.inet.report.Chart
    * CUSTOM_NUMER_FORMAT
    * getSort()
    * setdataValuesMinMax(double, double)
    * setSort(int)
  * com.inet.report.ChartFormatProperties
    * getDateFirstSeperator()
    * setDateFirstSeperator(String)
    * getDateFirstSeperatorFormula()
    * setDateFirstSeperatorFormula(FormulaField)
    * getDatePrefixSeperator()
    * setDatePrefixSeperator(String)
    * getDatePrefixSeperatorFormula()
    * setDatePrefixSeperatorFormula(FormulaField)
    * getDateSecondSeperator()
    * setDateSecondSeperator(String)
    * getDateSecondSeperatorFormula()
    * setDateSecondSeperatorFormula(FormulaField)
    * getDateSuffixSeperator()
    * setDateSuffixSeperator(String)
    * getDateSuffixSeperatorFormula()
    * setDateSuffixSeperatorFormula(FormulaField)
    * getDateTimeSeperator()
    * setDateTimeSeperator(String)
    * getDateTimeSeperatorFormula()
    * setDateTimeSeperatorFormula(FormulaField)
    * getDayOfWeekSeperator()
    * setDayOfWeekSeperator(String)
    * getDayOfWeekSeperatorFormula()
    * setDayOfWeekSeperatorFormula(FormulaField)
    * getDecimalSeperatorsSymbol()
    * setDecimalSeperatorsSymbol(String)
    * getDecimalSeperatorsSymbolFormula()
    * setDecimalSeperatorsSymbolFormula(FormulaField)
    * getHourMinuteSeperator()
    * setHourMinuteSeperator(String)
    * getHourMinuteSeperatorFormula()
    * setHourMinuteSeperatorFormula(FormulaField)
    * getMinuteSecondSeperator()
    * setMinuteSecondSeperator(String)
    * getMinuteSecondSeperatorFormula()
    * setMinuteSecondSeperatorFormula(FormulaField)
    * getThousandSeperatorsSymbol()
    * setThousandSeperatorsSymbol(String)
    * getThousandSeperatorsSymbolFormula()
    * setThousandSeperatorsSymbolFormula(FormulaField)
    * getUseThousandSeperators()
    * setUseThousandSeperators(boolean)
    * getUseThousandSeperatorsFormula()
    * setUseThousandSeperatorsFormula(FormulaField)
  * com.inet.report.CrossTab
    * getColTotalOnLeft()
  * com.inet.report.CrossTabCell
    * setHeightByFieldElements()
    * setWidthByFieldElement(int)
  * com.inet.report.DatabaseTables
    * addSproc(String, String[], int[])
    * addSproc(String, String, String[], int[])
    * addSqlSource(String)
    * addSqlSource(String, String)
    * getDistinct()
    * getPassword()
    * getUser()
    * setCatalog(String)
    * setColumnNames(String, String[])
    * setColumnTypes(String, int[])
    * setDistinct(boolean)
    * setDll(String)
    * setHost(String)
    * setPassword(String)
    * setSchema(String)
    * setURL="../../String"
    * setUser(String)
  * com.inet.report.Element
    * getBottomLineStyleFormel()
    * getToolTipsTextFormel()
    * getTopLineStyleFormel()
    * getWebSiteAddressFormel()
    * setWebSiteAddressFormula(FormulaField)
  * com.inet.report.Engine
    * getCatalog()
    * getConnection()
    * getDll()
    * getHost()
    * getPassword(int)
    * getPasswords()
    * getSchema()
    * getURL="changes_9.0.html" data-contextid="changes-in-release-90" data-rawid="documentation:clear-reports:release-notes:en:releases:changes_9.0"
    * getUser(int)
    * getUsers()
    * setDll(String)
    * setHost(String)
    * setPassword(String, int)
    * setPasswords(Vector)
    * setSql(String, boolean)
    * setURL="../../String"
    * setUser(String, int)
    * setUsers(Vector)
  * com.inet.report.Fields
    * addDatabaseField(String)
    * addSortField( field, String)
  * com.inet.report.FormulaField
    * checkFormula(String, boolean, Engine, Field, Object, boolean)
  * com.inet.report.GeneralProperties
    * getToolTipsTextFormel()
  * com.inet.report.HyperlinkProperties
    * getWebSiteAddressFormel()
    * setWebSiteAddressFormula(FormulaField)
  * com.inet.report.JavaBean
    * getBeanProperty(String)
  * com.inet.report.LineProperties
    * getExtentToBottomOfSectionWhenPrinting()
  * com.inet.report.SortField
    * setSortDirectionFormula(String)
  * com.inet.report.TableSource
    * setColumnName(int idx, String)
    * setColumnType(int, int)
  * com.inet.report.ValueProperties
    * getDateFirstSeperator()
    * setDateFirstSeperator(String)
    * getDateFirstSeperatorFormula()
    * setDateFirstSeperatorFormula(FormulaField)
    * getDatePrefixSeperator()
    * setDatePrefixSeperator(String)
    * getDatePrefixSeperatorFormula()
    * setDatePrefixSeperatorFormula(FormulaField)
    * getDateSecondSeperator()
    * setDateSecondSeperator(String)
    * getDateSecondSeperatorFormula()
    * setDateSecondSeperatorFormula(FormulaField)
    * getDateSuffixSeperator()
    * setDateSuffixSeperator(String)
    * getDateSuffixSeperatorFormula()
    * setDateSuffixSeperatorFormula(FormulaField)
    * getDateTimeSeperator()
    * setDateTimeSeperator(String)
    * getDateTimeSeperatorFormula()
    * setDateTimeSeperatorFormula(FormulaField)
    * getDayOfWeekSeperator()
    * setDayOfWeekSeperator(String)
    * getDayOfWeekSeperatorFormula()
    * setDayOfWeekSeperatorFormula(FormulaField)
    * getDecimalSeperatorsSymbol()
    * setDecimalSeperatorsSymbol(String)
    * getDecimalSeperatorsSymbolFormula()
    * setDecimalSeperatorsSymbolFormula(FormulaField)
    * getHourMinuteSeperator()
    * setHourMinuteSeperator(String)
    * getHourMinuteSeperatorFormula()
    * setHourMinuteSeperatorFormula(FormulaField)
    * getMinuteSecondSeperator()
    * setMinuteSecondSeperator(String)
    * getMinuteSecondSeperatorFormula()
    * setMinuteSecondSeperatorFormula(FormulaField)
    * getThousandSeperatorsSymbol()
    * setThousandSeperatorsSymbol(String)
    * getThousandSeperatorsSymbolFormula()
    * setThousandSeperatorsSymbolFormula(FormulaField)
    * getUseThousandSeperators()
    * setUseThousandSeperators(boolean)
    * getUseThousandSeperatorsFormula()
    * setUseThousandSeperatorsFormula(FormulaField)

#### External Libraries
* Swing-Layout (swing-layout.jar) version 1.2 added.
* SwingWorker (swing-worker.jar) version 1.0.3 added.
* Echo2 version 2.1 added (for Remote Configuration).
* JFreeChart updated with version 1.0.12.
* JGauge Bean added.
* SVGSalamder Bean updated.
* Lucene Search Engine (lucene-core.jar) version 2.4.1 added.
* Milton webdav API version 1.4.2 added.
* Mimetype utilities version 2.1 added.
* slf4j version 1.5.6 added.

### i-net Crystal-Clear - Java Viewer
* New API methods:
  * com.inet.viewer.ReportView: setAutoRefresh(int)

Specifies an auto-refresh cycle for a Report View, causing it to be refreshed every so often unless the report view was canceled or is currently being reloaded anyways. Also, introduced new URL parameter "autorefresh=xxxx" - allows the auto-refresh cycle to be specified (in milliseconds) via URL parameter.
  * com.inet.viewer.SwingReportViewer.setDefaultSetting

Enables you to set certain settings for the viewer. For example you can set the default page view to be continuous, or a certain zoom level to be taken by default.

The keys and values which can be set are in the class com.inet.viewer.props.DefaultSetting.
  * com.inet.viewer.SwingReportViewer.setCustomPromptEditor(String, int) 

Allows you to specify not only the name of the prompt you wish to register a stomPromptEditor for, but also the value type the prompt must have in order for your CustomPromptEditor to be used.
  * com.inet.viewer.ViewerContext.showUrl="../../String-Properties"

It is now possible to implement your own "showURL" method for the viewer which is called any time a user clicks on a link in a report (since build 9.0.130).
* Export dialog: Image export formats (JPG, PNG, BMP, GIF) added.
* Print dialog: It is now possible to specify pages and page ranges that will be print separated by commas.
* Reports saved with an embedded viewer (JRA/JAR) now use the System L&F in order to keep the same L&F as used in the Viewer applet. (build 9.0.130).
* Performance of the Java report viewer has been improved on Mac OS X and Linux with Java 5.
* In the viewer prompt dialog panel for setting date ranges, the default calendar week was the first week of the range originally chosen, this has been changed to be the last completed calendar week by default.

#### API Changes
* Added Class
  * com.inet.viewer.props.DefaultSetting
* Added Methods
  * com.inet.viewer.ReportView
    * setAutoRefresh(int)
  * com.inet.viewer.ReportViewer
    * setCustomPromptEditor(String, int, CustomPromptEditor)
  * com.inet.viewer.SwingReportViewer
    * SwingReportViewer(ViewerContext)
    * setCustomPromptEditor(String, int, CustomPromptEditor)
    * getDefaultSetting(DefaultSetting.Key)
    * setDefaultSetting(DefaultSetting.Key, DefaultSetting)
  * com.inet.viewer.SwingViewerContext
    * getViewer()
    * setViewer(SwingReportViewer)
  * com.inet.viewer.ViewerContext
    * showUrl="../../String-Properties"
* Methods and Constants deprecated as of Version 9
  * com.inet.viewer.ReportViewer
    * setCustomPromptEditor(String, CustomPromptEditor)

### i-net DesignerXML
* Welcome page added.
* Step-By-Step Tutorials added.
* **Default Values for fonts etc. supported.** -  It is now supported to set default values for the formatting properties used for newly created elements in i-net DesignerXML.
* Report Preview in the file open dialog added.
* **Progress Bar added.** -  The i-net DesignerXML now shows a progress bar when a process may be taking a while, for example when attempting a database connection or when loading a large report. This process can also be canceled at any time. This fixes the old behavior which was to lock up the designer until the processes were finished.
* Field browser now supports duplicating and renaming of formula, prompt, sql expression and summary fields.
* It is now possible to use a sum in other sums. Note the sums should be created in the correct order.
* When opening up a property formula, possible constants which can be returned for the formula are displayed as a comment in the formula dialog.
* **Chart Properties: ** -  It is now possible to set seconds in the calendar.
* **Formula Editor: ** -  The marking of incorrect parts of the formula has been improved.
* **Subreport Links: ** -  It is now possible to change the width of the tree in the ort links dialog.
* **Parameter Properties: ** -  There are 3 new keyboard shortcuts within the Designer's Parameter Field Properties dialog: Ctrl+N creates a new prompt, Alt+Up moves a prompt up within the list, Alt+Down moves a prompt down within the list.
* The designer now has an internal backup system while overwriting reports while saving in order to prevent data loss if the saving of a report does not finish correctly (build 9.0.130).
* **Document Properties:** -  Property "Report Locale" added to the document properties (build 9.0.170).
* New command line parameter "–new" added to start the i-net DesignerXML with a new report 
* On Mac OS X the CMD key is now used for menu items and features instead of the STRG or CTRL key (build 9.0.170).
* Start script "startDesigner.command" for Mac OS X added (build 9.0.170).

#### API Changes
* Added Methods
  * com.inet.designer.DesignerDataModel
    * loadReportFrom(Component, File)

#### External Libraries
* Step-By-Step Tutorial (SBSTutorial.jar) version 1.0 added.

### Setup
* Improved selection of installation type and component selection.
* ISAPI has been replaced with ASP.NET.
* Registration of file extensions ".rpt" and ".jra" possible during setup.

[changes:de]
* **Geändertes Verhalten von Formeln mit der Auswertungszeit WhileReadingRecords:**
  * Alle Formeln mit der Auswertungszeit WhileReadingRecords, die im Bericht verwendet werden, werden nun ausgeführt, bevor das Rendering des ersten Abschnitts beginnt.
  * Variablen, die in Formeln mit der Auswertungszeit WhileReadingRecords verwendet werden, werden vor Beginn des Renderings nicht zurückgesetzt, so dass die Variablen auch in Formeln mit der Auswertungszeit WhilePrintingRecords verwendet werden können.

Aufgrund dieses geänderten Verhaltens kann es notwendig sein, Ihre Berichte mit der Funktion WhileReadingRecords zu aktualisieren, damit Sie das gleiche Ergebnis wie mit früheren i-net Crystal-Clear-Versionen erhalten. Es ist leider notwendig, diese Verhaltensänderung vorzunehmen, da das alte Verhalten nicht korrekt war.

Wenn Sie eine ältere Konfiguration mit i-net Crystal-Clear Version 9 verwenden, müssen Sie die Kompatibilitätsebene auf "kompatibel zu Version 9.x" setzen, um das neue Verhalten der "WhileReadingRecords"-Formeln zu nutzen. Wenn Sie eine neue Konfiguration mit Version 9 erstellen, dann ist "kompatibel zu Version 9.x" der Standardwert.
* **Zusammenfassungsfunktionen überarbeitet:** Die Zusammenfassungsfunktionen wurden komplett überarbeitet, um die Leistung und Kompatibilität zu optimieren. Dies sind die Hauptauswirkungen dieser Änderung:
  * bei der Ausführung von Gesamtzusammenfassungen kann jedes Datenbank-, Formel- oder Gruppenfeld als Auswertungs- oder Rücksetzbedingung verwendet werden
  * in laufenden Gesamtzusammenfassungen können jetzt auch nicht-boolesche Formelfelder als Auswerte- oder Rücksetzbedingung verwendet werden
  * laufende Gesamtzusammenfassungen haben jetzt die gleichen Auswirkungen auf die Leistung wie nicht laufende Gesamtzusammenfassungen, benötigen aber immer noch mehr Speicher
  * es ist jetzt immer sicher, andere Statistikfelder zu verdichten
  * nicht-statistische Funktionen haben einen Anfangswert von 'null' anstelle von Null
  * das Hinzufügen eines oder mehrerer 'Null'-Werte zu einer Zusammenfassung ändert das Ergebnis nicht
  * korrelation und Kovarianz geben jetzt 1 zurück, wenn ihr Ergebnis undefiniert ist
  * pth Percentile' hat jetzt eine präzisere Abstufung
  * nth most frequent' gruppiert jetzt immer nach Häufigkeit und ordnet aufsteigend nach Wert, bevor der n-te Wert zurückgegeben wird.
* **Verbessertes Berichtsdateiformat:** Ab Version 9 verwendet i-net Crystal-Clear ein komprimiertes Dateiformat für die Berichtsvorlagen (.rpt), ähnlich dem OpenDocument zip-Dateiformat. Dieses neue Berichtsdateiformat war eine Voraussetzung für neue Funktionen wie die Berichtsvorschau. Mit diesem Format wurde die Leistung insbesondere bei großen Berichten verbessert, da die Dateigröße kleiner und schneller ist. Außerdem sind wir mit diesem Format offen für weitere Ergänzungen der Berichtsvorlagen.
* **Neue Exportformate: BMP, GIF, JPG und PNG:** Mit Version 9 ist es möglich, eine einzelne Berichtsseite als Bild zu exportieren. Die folgenden Formate werden unterstützt: BMP, GIF (mit mindestens Java 6 auf dem Server), JPG und PNG.

Mit den Report-URL-Parametern Zoom, Breite, Höhe und Hintergrund ist es auch möglich, das exportierte Bild zu konfigurieren.
* **Neuer Renderer für die Textinterpretation: HTML (advanced):** Felder mit Textinterpretation "HTML (advanced)" verwenden nun den HTML-Renderer von i-net software. Dies behebt viele Probleme, die mit dem HTML-Renderer von Swing auftraten, der zuvor für diese Felder verwendet wurde.
* **Berichts-URL-Parameter sind standardmäßig nicht erlaubt:** Aus Sicherheitsgründen sind **nur** die folgenden Parameter in der Berichts-URL standardmäßig **erlaubt**: "prompt", "init" und "sproc". Um andere Parameter in der Berichts-URL zu verwenden, wie z.B. "datasource", ist es notwendig, diese im Konfigurationsmanager freizuschalten, bevor sie verwendet werden.

Es ist immer möglich, Werte für alle Parameter in der checkProperties-Methode auf der Server-Seite zu setzen. Java-Code-Beispiele, die dies zeigen, finden Sie im Verzeichnis "sample" der Dokumentation (falls installiert).
* **Underlay Following Sections:** Der Algorithmus für "Underlay Following Sections" wurde umgeschrieben, um die korrekte Definition zu implementieren. Dies kann die Ausgabe Ihrer Berichte verändern, wenn Sie von Fehlern in der alten Implementierung betroffen waren. Ein Vorteil ist, dass Sie nun ohne Probleme Berichte mit Wasserzeichen erstellen können. Wenn Sie ein Wasserzeichen erstellen möchten, müssen Sie lediglich einen ersten Abschnitt zum Berichts-/Seitenkopf hinzufügen und die Option "Folgende Abschnitte unterlegen" für diesen Abschnitt aktivieren. Sie sollten das Bild entweder im Bericht oder im Seitenkopf platzieren, je nachdem, ob Sie ein Wasserzeichen pro Bericht oder eines pro Seite wünschen.
* **i-net DesignerXML - Standardwerte:** Mit Version 9.0 ist es möglich, Standardwerte für die Formatierungseigenschaften für neu erstellte Elemente in i-net DesignerXML festzulegen.

Allgemeine, Schriftart- und Rahmeneigenschaften können für alle Elementtypen, wie z. B. Datenbankfelder, Statistikfelder, Gruppennamensfelder und Textobjekte, festgelegt werden.

Text-, Absatz- und Werteigenschaften können je nach Feldtyp eingestellt werden, z. B. für String-, Zahlen-, Währungs-, Datums-, Zeit-, DateTime- und boolesche Felder.
* **i-net DesignerXML - Berichtsvorschau:** Eine Vorschau des Berichts wird auf der rechten Seite des Dialogs "Datei öffnen" von i-net DesignerXML angezeigt, wenn der Bericht mindestens einmal ausgeführt und mit Version 9 gespeichert wurde.
* **i-net DesignerXML - Signaturelement:** Mit einem Signaturelement ist es möglich, Signaturinformationen in der exportierten PDF-Datei anzuzeigen. Das Signaturelement ist weder im Java Viewer noch in den anderen Exportformaten sichtbar. Um das Signaturelement zu verwenden, muss die PDF-Signierung im i-net Crystal-Clear Configuration Manager unter "Export -> PDF-Dateien signieren" aktiviert und konfiguriert werden.
* **i-net DesignerXML - Übersetzungseinstellungen / Ressourcenbündel pro Bericht:** Mit den Übersetzungseinstellungen können Sie Übersetzungen für einen Bericht erstellen, bearbeiten, entfernen, importieren und/oder exportieren, so dass es möglich ist, einen Bericht für mehrere Sprachen zu erstellen. Die Übersetzungsressourcen werden in der Berichtsdatei gespeichert und werden bei der Ausführung des Berichts verwendet. Um sie zu öffnen, wählen Sie "Übersetzungen..." aus dem Berichtsmenü.
* **i-net DesignerXML - Willkommensseite:** Die Willkommensseite wird nach dem Start von i-net DesignerXML angezeigt. Die verfügbaren Ressourcen werden in verschiedenen Bereichen dieser Seite angezeigt, so dass der Benutzer leicht auf sie zugreifen kann.

Mit dem Kontrollkästchen am unteren Rand der Willkommensseite kann der Benutzer entscheiden, ob er diese Seite in Zukunft sehen möchte. Wenn sie deaktiviert ist, kann er sie über den Menüpunkt im Hilfemenü wieder anzeigen lassen.
* **Schritt-für-Schritt-Tutorials:** Die Schritt-für-Schritt-Tutorials führen den Benutzer durch die einzelnen Schritte der Arbeit mit i-net DesignerXML.

Der Benutzer kann die Tutorials auf der Willkommensseite oder im Menü "Hilfe" aufrufen.
* **Setup - Verbesserte Auswahl des Installationstyps und der Komponentenauswahl:** Auf der ersten Seite des Setups kann der Benutzer leicht entscheiden, ob er i-net DesignerXML oder i-net Crystal-Clear als Berichtsserver installieren möchte. Wenn der Benutzer auf Serverinstallation klickt, kann er auf der nächsten Seite die Installationsumgebung auswählen. Bei der benutzerdefinierten Installation ist es weiterhin möglich, sowohl i-net DesignerXML als auch den Berichtsserver oder das Servlet in einem Schritt zu installieren.

### i-net Crystal-Clear-Runtime
* Neuer Remote Configuration Manager für die Online-Verwaltung von i-net Crystal-Clear. Er ermöglicht es Ihnen, die Serverkonfigurationen von jedem beliebigen PC aus zu verwalten.
* **Verbessertes rpt-Dateiformat** - Seit Version 9 wird ein gezipptes Dateiformat für die Berichtsvorlagen (.rpt) verwendet.
* ReportReaderNet für Berichte, die mit Crystal Reports XI R2 oder höher erstellt wurden.
* Bild-Exportformate hinzugefügt: PNG, JPG, BMP und GIF (Java 6 oder höher).

URL-Parameter-Optionen sind Zoom, Breite, Höhe und Hintergrund.
* **Startseite hinzugefügt. ** - Sie kann mit einer der folgenden URLs aufgerufen werden:
  * `http://<Servername>:<Port>` (für Berichtsserver)
  * `http://<Servername>:<Port>/<Kontext>` (für Report Servlets)
* **Report-URL-Parameter standardmäßig deaktiviert** - Aus Sicherheitsgründen sind **nur** die folgenden Report-URL-Parameter standardmäßig in der Report-URL **erlaubt**: "prompt", "init" und "sproc". Um andere Parameter in der Berichts-URL zu verwenden, wie z.B. "datasource", ist es notwendig, diese im Konfigurationsmanager freizuschalten, bevor sie verwendet werden.
* Neue API-Methode:
  * Feld.duplizieren(String)

Dupliziert das Feld und gibt das erstellte Feld mit dem angegebenen Namen zurück. Diese Methode kann nur für kopierbare Felder aufgerufen werden, d. h. Formel-, Eingabeaufforderungs-, SQL- und Statistikfelder. Alle anderen Felder lösen eine UnsupportedOperationException aus.
  * Cache.getxxxAndWait Methoden mit Timeout Parameter hinzugefügt.
* Neue Eigenschaft: Für die Optionen "report location" in den Einstellungen für die Berichtsberechtigung ist jetzt die Option "JNDI location allowed" verfügbar.
* Felder mit Textinterpretation "HTML (advanced)" verwenden jetzt den HTML-Renderer von i-net software. Dies behebt viele Probleme, die mit dem HTML-Renderer von Swing auftraten, der zuvor für diese Felder verwendet wurde.
* Hyperlinks auf Box-Elementen werden unterstützt.
* Neue Java Bean hinzugefügt: JGauge. Kann verwendet werden, um Messdiagramme in den Berichten anzuzeigen.
* HTML-Export: Die Autorefresh-Funktion wurde nun auch für den HTML-Export implementiert - die Verwendung des Parameters "autorefresh" bewirkt, dass die Seite alle x Millisekunden neu geladen wird, z.B. "autorefresh=10000" für eine Aktualisierung der Seite alle 10 Sekunden (Build 9.0.130).
* Der HTML-Parameter-Anforderungsdialog wird je nach Gebietsschema des Clients übersetzt (Build 9.0.155).
* Unter Linux/Unix wurde die Datei "Listener.sh" hinzugefügt. Sie kann zum Starten, Stoppen und Neustarten des Berichtsserver-Listeners verwendet werden (Build 9.0.170).
* Startskripte "startListener.command" und "startConfigurationManager.command" für Mac OS X hinzugefügt (Build 9.0.170).

* Das fehlerhafte Verhalten von WhileReadingRecords-Formeln wurde geändert.
  * Alle Formeln mit der Auswertungszeit WhileReadingRecords, die im Bericht verwendet werden, werden nun ausgeführt, bevor das Rendering des ersten Abschnitts beginnt.
  * Variablen, die in Formeln mit der Auswertungszeit WhileReadingRecords verwendet werden, werden vor Beginn des Renderings nicht zurückgesetzt, so dass die Variablen auch in Formeln mit der Auswertungszeit WhilePrintingRecords verwendet werden können.
* Es wird nicht mehr unterstützt, Zusammenfassungsfunktionen in WhileReadingRecords-Formeln zu verwenden. Diese Formeln werden automatisch auf WhilePrintingRecords gesetzt.
* Es ist jetzt möglich zu wählen, wie Formeln auf leere Datenbankfelder reagieren sollen.
* Unter Windows befinden sich die ReportReader-Tools jetzt im gemeinsamen Ordner Program Files.
* Die Konfigurationseigenschaften und ihre Werte werden jetzt in alphabetischer Reihenfolge in der Protokollausgabe protokolliert, um das Auffinden einer Konfigurationseinstellung zu erleichtern.
* Diagramm:
  * Die Behandlung von Nullwerten in den kontinuierlichen Diagrammen wurde geändert. Das Diagramm ignoriert jetzt die Nullwerte des Kategoriegruppenfeldes.
  * Eine 'für jeden Datensatz'-Konfiguration unterstützt nun auch die Farbformel.
* Der Berichtsname wird im Speicherdialog des Browsers vorgeschlagen, wenn der Bericht-URL-Parameter "init=<export-format>" zum Exportieren eines Berichts verwendet wird. Zuvor wurde der Servername vorgeschlagen.
* Tabellenaliasnamen, die nur aus Ziffern bestehen, werden mit dem Präfix 'z' geschrieben.
* Gruppenauswahl-Formel:
  * Jetzt wird jeder Datensatz gefiltert, nicht nur ein Datensatz pro Gruppe.
  * Wird jetzt auch ausgeführt, wenn es keine Gruppen im Bericht gibt.
* Sobald eine Konfiguration geändert oder eine neue eingestellt wird, aktualisiert i-net Crystal-Clear automatisch seine Einstellungen. Bisher wurden die Einstellungen nur aktualisiert, sobald versucht wurde, einen Bericht zu rendern.
* Formelfehler, die im Bericht angezeigt werden, werden jetzt mit der Zeichenfolge "Formelfehler:" eingeleitet, um Missverständnisse in Abhängigkeit von der Formelfehlermeldung zu vermeiden (seit Build 9.0.130).
* PDF-Export: EUDC-Zeichen werden mit Hilfe der EUDC-Schriftart gerendert, auch wenn die Schriftart des Absatzes oder des Feldes keine EUDC-Schriftart ist. Die EUDC-Schriftart muss den Namen 'EUDC.tte' tragen und sich im FontPath-Verzeichnis befinden. Die Schriftart des Absatzes oder des Feldes muss ebenfalls eine eingebettete Schriftart sein (Build 9.0.175).

#### API-Änderungen
* Konstanten hinzugefügt
  * com.inet.report.Engine
    * EXPORT_BMP
    * EXPORT_GIF
    * EXPORT_JPG
    * EXPORT_PNG
  * com.inet.report.FormulaField
    * TREAT_NULL_AS_NULL
    * TREAT_NULL_BY_DEFAULT
    * TREAT_NULL_BY_EXCEPTION
* Hinzugefügte Methoden
  * com.inet.report.Cache
    * getxxxAndWait(xxxx, "int timeout)"
  * com.inet.report.Datasource
    * setDataSourceConfiguration(DataSourceConfiguration)
    * setDataSourceConfigurationName(String)
  * com.inet.report.Engine
    * setDataSourceConfigurationName(String)
  * com.inet.report.Field
    * duplicate(String)
  * com.inet.report.FormulaField
    * checkContext()
    * checkFormula(String, boolean, Engine, Field, Object, int, int)
    * duplicate(String)
    * getNullBehavior()
    * setNullBehavior(int)
  * com.inet.report.Line
    * setHyperlinkUrl="../../String"
    * setHyperlinkUrlFormula(FormulaField)
  * com.inet.report.PromptField
    * duplicate(String)
  * com.inet.report.ReportProperties
    * isCCFormat()
    * getXMLMajorVersion()
    * getXMLMinorVersion()
  * com.inet.report.SummaryInfo
    * getThumbnail()
    * setThumbnail(Image)
  * com.inet.report.SQLField
    * duplicate(String)
  * com.inet.report.SummaryField
    * duplicate(String)
  * com.inet.report.TableSource
    * getDatabaseField(int)
* Methoden und Konstanten, die ab Version 9 veraltet sind
  * com.inet.report.Datasource
    * setup(String)
    * setup(DataSourceConfiguration)
  * com.inet.report.RDC
    * loadEngine(File, BufferedReader)
    * loadEngine(File, BufferedReader, Properties)
    * Engine loadEngine(File, BufferedReader, String)
    * saveEngine(PrintWriter, Engine)
* Entfernte veraltete Methoden und Konstanten
  * com.inet.report.schedule.Scheduler
    * getEmailPassword()
    * setEmailPassword(String)
    * getEmailPop3Host()
    * setEmailPop3Host(String)
    * getEmailSender()
    * setEmailSender(String)
    * getEmailSmtpHost()
    * setEmailSmtpHost(String)
    * getEmailUser()
    * setEmailUser(String)
  * com.inet.report.AbstractLineElement
    * getExtentToBottomOfSectionWhenPrinting()
  * com.inet.report.AbstractValueElement
    * getDateFirstSeperator()
    * setDateFirstSeperator(String)
    * getDateFirstSeperatorFormula()
    * setDateFirstSeperatorFormula(FormulaField)
    * getDatePrefixSeperator()
    * setDatePrefixSeperator(String)
    * getDatePrefixSeperatorFormula()
    * setDatePrefixSeperatorFormula(FormulaField)
    * getDateSecondSeperator()
    * setDateSecondSeperator(String)
    * getDateSecondSeperatorFormula()
    * setDateSecondSeperatorFormula(FormulaField)
    * getDateSuffixSeperator()
    * setDateSuffixSeperator(String)
    * getDateSuffixSeperatorFormula()
    * setDateSuffixSeperatorFormula(FormulaField)
    * getDateTimeSeperator()
    * setDateTimeSeperator(String)
    * getDateTimeSeperatorFormula()
    * setDateTimeSeperatorFormula(FormulaField)
    * getDayOfWeekSeperator()
    * setDayOfWeekSeperator(String)
    * getDayOfWeekSeperatorFormula()
    * setDayOfWeekSeperatorFormula(FormulaField)
    * getDecimalSeperatorsSymbol()
    * setDecimalSeperatorsSymbol(String)
    * getDecimalSeperatorsSymbolFormula()
    * setDecimalSeperatorsSymbolFormula(FormulaField)
    * getHourMinuteSeperator()
    * setHourMinuteSeperator(String)
    * getHourMinuteSeperatorFormula()
    * setHourMinuteSeperatorFormula(FormulaField)
    * getMinuteSecondSeperator()
    * setMinuteSecondSeperator(String)
    * getMinuteSecondSeperatorFormula()
    * setMinuteSecondSeperatorFormula(FormulaField)
    * getThousandSeperatorsSymbol()
    * setThousandSeperatorsSymbol(String)
    * getThousandSeperatorsSymbolFormula()
    * setThousandSeperatorsSymbolFormula(FormulaField)
    * getUseThousandSeperators()
    * setUseThousandSeperators(boolean)
    * getUseThousandSeperatorsFormula()
    * setUseThousandSeperatorsFormula(FormulaField)
  * com.inet.report.BorderProperties
    * getBottomLineStyleFormel()
    * getTopLineStyleFormel()
  * com.inet.report.Chart
    * CUSTOM_NUMER_FORMAT
    * getSort()
    * setdataValuesMinMax(double, double)
    * setSort(int)
  * com.inet.report.ChartFormatProperties
    * getDateFirstSeperator()
    * setDateFirstSeperator(String)
    * getDateFirstSeperatorFormula()
    * setDateFirstSeperatorFormula(FormulaField)
    * getDatePrefixSeperator()
    * setDatePrefixSeperator(String)
    * getDatePrefixSeperatorFormula()
    * setDatePrefixSeperatorFormula(FormulaField)
    * getDateSecondSeperator()
    * setDateSecondSeperator(String)
    * getDateSecondSeperatorFormula()
    * setDateSecondSeperatorFormula(FormulaField)
    * getDateSuffixSeperator()
    * setDateSuffixSeperator(String)
    * getDateSuffixSeperatorFormula()
    * setDateSuffixSeperatorFormula(FormulaField)
    * getDateTimeSeperator()
    * setDateTimeSeperator(String)
    * getDateTimeSeperatorFormula()
    * setDateTimeSeperatorFormula(FormulaField)
    * getDayOfWeekSeperator()
    * setDayOfWeekSeperator(String)
    * getDayOfWeekSeperatorFormula()
    * setDayOfWeekSeperatorFormula(FormulaField)
    * getDecimalSeperatorsSymbol()
    * setDecimalSeperatorsSymbol(String)
    * getDecimalSeperatorsSymbolFormula()
    * setDecimalSeperatorsSymbolFormula(FormulaField)
    * getHourMinuteSeperator()
    * setHourMinuteSeperator(String)
    * getHourMinuteSeperatorFormula()
    * setHourMinuteSeperatorFormula(FormulaField)
    * getMinuteSecondSeperator()
    * setMinuteSecondSeperator(String)
    * getMinuteSecondSeperatorFormula()
    * setMinuteSecondSeperatorFormula(FormulaField)
    * getThousandSeperatorsSymbol()
    * setThousandSeperatorsSymbol(String)
    * getThousandSeperatorsSymbolFormula()
    * setThousandSeperatorsSymbolFormula(FormulaField)
    * getUseThousandSeperators()
    * setUseThousandSeperators(boolean)
    * getUseThousandSeperatorsFormula()
    * setUseThousandSeperatorsFormula(FormulaField)
  * com.inet.report.CrossTab
    * getColTotalOnLeft()
  * com.inet.report.CrossTabCell
    * setHeightByFieldElements()
    * setWidthByFieldElement(int)
  * com.inet.report.DatabaseTables
    * addSproc(String, String[], int[])
    * addSproc(String, String, String[], int[])
    * addSqlSource(String)
    * addSqlSource(String, String)
    * getDistinct()
    * getPassword()
    * getUser()
    * setCatalog(String)
    * setColumnNames(String, String[])
    * setColumnTypes(String, int[])
    * setDistinct(boolean)
    * setDll(String)
    * setHost(String)
    * setPassword(String)
    * setSchema(String)
    * setURL="../../String"
    * setUser(String)
  * com.inet.report.Element
    * getBottomLineStyleFormel()
    * getToolTipsTextFormel()
    * getTopLineStyleFormel()
    * getWebSiteAddressFormel()
    * setWebSiteAddressFormula(FormulaField)
  * com.inet.report.Engine
    * getCatalog()
    * getConnection()
    * getDll()
    * getHost()
    * getPassword(int)
    * getPasswords()
    * getSchema()
    * getURL="changes_9.0.html" data-contextid="changes-in-release-90" data-rawid="documentation:clear-reports:release-notes:en:releases:changes_9.0"
    * getUser(int)
    * getUsers()
    * setDll(String)
    * setHost(String)
    * setPassword(String, int)
    * setPasswords(Vector)
    * setSql(String, boolean)
    * setURL="../../String"
    * setUser(String, int)
    * setUsers(Vector)
  * com.inet.report.Fields
    * addDatabaseField(String)
    * addSortField( field, String)
  * com.inet.report.FormulaField
    * checkFormula(String, boolean, Engine, Field, Object, boolean)
  * com.inet.report.GeneralProperties
    * getToolTipsTextFormel()
  * com.inet.report.HyperlinkProperties
    * getWebSiteAddressFormel()
    * setWebSiteAddressFormula(FormulaField)
  * com.inet.report.JavaBean
    * getBeanProperty(String)
  * com.inet.report.LineProperties
    * getExtentToBottomOfSectionWhenPrinting()
  * com.inet.report.SortField
    * setSortDirectionFormula(String)
  * com.inet.report.TableSource
    * setColumnName(int idx, String)
    * setColumnType(int, int)
  * com.inet.report.ValueProperties
    * getDateFirstSeperator()
    * setDateFirstSeperator(String)
    * getDateFirstSeperatorFormula()
    * setDateFirstSeperatorFormula(FormulaField)
    * getDatePrefixSeperator()
    * setDatePrefixSeperator(String)
    * getDatePrefixSeperatorFormula()
    * setDatePrefixSeperatorFormula(FormulaField)
    * getDateSecondSeperator()
    * setDateSecondSeperator(String)
    * getDateSecondSeperatorFormula()
    * setDateSecondSeperatorFormula(FormulaField)
    * getDateSuffixSeperator()
    * setDateSuffixSeperator(String)
    * getDateSuffixSeperatorFormula()
    * setDateSuffixSeperatorFormula(FormulaField)
    * getDateTimeSeperator()
    * setDateTimeSeperator(String)
    * getDateTimeSeperatorFormula()
    * setDateTimeSeperatorFormula(FormulaField)
    * getDayOfWeekSeperator()
    * setDayOfWeekSeperator(String)
    * getDayOfWeekSeperatorFormula()
    * setDayOfWeekSeperatorFormula(FormulaField)
    * getDecimalSeperatorsSymbol()
    * setDecimalSeperatorsSymbol(String)
    * getDecimalSeperatorsSymbolFormula()
    * setDecimalSeperatorsSymbolFormula(FormulaField)
    * getHourMinuteSeperator()
    * setHourMinuteSeperator(String)
    * getHourMinuteSeperatorFormula()
    * setHourMinuteSeperatorFormula(FormulaField)
    * getMinuteSecondSeperator()
    * setMinuteSecondSeperator(String)
    * getMinuteSecondSeperatorFormula()
    * setMinuteSecondSeperatorFormula(FormulaField)
    * getThousandSeperatorsSymbol()
    * setThousandSeperatorsSymbol(String)
    * getThousandSeperatorsSymbolFormula()
    * setThousandSeperatorsSymbolFormula(FormulaField)
    * getUseThousandSeperators()
    * setUseThousandSeperators(boolean)
    * getUseThousandSeperatorsFormula()
    * setUseThousandSeperatorsFormula(FormulaField)

#### Externe Bibliotheken
* Swing-Layout (swing-layout.jar) Version 1.2 hinzugefügt.
* SwingWorker (swing-worker.jar) Version 1.0.3 hinzugefügt.
* Echo2 Version 2.1 hinzugefügt (für Fernkonfiguration).
* JFreeChart aktualisiert mit Version 1.0.12.
* JGauge Bean hinzugefügt.
* SVGSalamder Bean aktualisiert.
* Lucene Search Engine (lucene-core.jar) Version 2.4.1 hinzugefügt.
* Milton webdav API Version 1.4.2 hinzugefügt.
* Mimetype Dienstprogramme Version 2.1 hinzugefügt.
* slf4j Version 1.5.6 hinzugefügt.

### i-net Crystal-Clear - Java Viewer
* Neue API-Methoden:
  * com.inet.viewer.ReportView: setAutoRefresh(int)

Legt einen Auto-Refresh-Zyklus für eine Report-Ansicht fest, der bewirkt, dass diese in regelmäßigen Abständen aktualisiert wird, es sei denn, die Report-Ansicht wurde abgebrochen oder wird gerade ohnehin neu geladen. Außerdem wurde der neue URL-Parameter "autorefresh=xxxx" eingeführt - ermöglicht die Angabe des automatischen Aktualisierungszyklus (in Millisekunden) über einen URL-Parameter.
  * com.inet.viewer.SwingReportViewer.setDefaultSetting

Ermöglicht es Ihnen, bestimmte Einstellungen für den Viewer festzulegen. Zum Beispiel können Sie die Standard-Seitenansicht als fortlaufend oder eine bestimmte Zoomstufe als Standard festlegen.

Die Schlüssel und Werte, die gesetzt werden können, sind in der Klasse com.inet.viewer.props.DefaultSetting enthalten.
  * com.inet.viewer.SwingReportViewer.setCustomPromptEditor(String, int)

Ermöglicht es Ihnen, nicht nur den Namen des Prompts anzugeben, für den Sie einen CustomPromptEditor registrieren möchten, sondern auch den Wertetyp, den der Prompt haben muss, damit Ihr CustomPromptEditor verwendet werden kann.
  * com.inet.viewer.ViewerContext.showUrl="../../String-Properties"

Es ist nun möglich, eine eigene "showURL"-Methode für den Viewer zu implementieren, die jedes Mal aufgerufen wird, wenn ein Benutzer auf einen Link in einem Bericht klickt (seit Build 9.0.130).
* Export-Dialog: Bild-Exportformate (JPG, PNG, BMP, GIF) hinzugefügt.
* Druck-Dialog: Es ist jetzt möglich, Seiten und Seitenbereiche anzugeben, die durch Kommas getrennt gedruckt werden sollen.
* Berichte, die mit einem eingebetteten Viewer (JRA/JAR) gespeichert werden, verwenden jetzt die System-L&F, um die gleiche L&F wie im Viewer-Applet zu verwenden. (Build 9.0.130).
* Die Leistung des Java Report Viewers wurde unter Mac OS X und Linux mit Java 5 verbessert.

* Im Dialogfeld der Viewer-Eingabeaufforderung zum Festlegen von Datumsbereichen war die Standard-Kalenderwoche die erste Woche des ursprünglich gewählten Bereichs. Dies wurde geändert, um standardmäßig die letzte abgeschlossene Kalenderwoche zu verwenden.

#### API-Änderungen
* Klasse hinzugefügt
  * com.inet.viewer.props.DefaultSetting
* Hinzugefügte Methoden
  * com.inet.viewer.ReportView
    * setAutoRefresh(int)
  * com.inet.viewer.ReportViewer
    * setCustomPromptEditor(String, int, CustomPromptEditor)
  * com.inet.viewer.SwingReportViewer
    * SwingReportViewer(ViewerContext)
    * setCustomPromptEditor(String, int, CustomPromptEditor)
    * getDefaultSetting(DefaultSetting.Key)
    * setDefaultSetting(DefaultSetting.Key, DefaultSetting)
  * com.inet.viewer.SwingViewerContext
    * getViewer()
    * setViewer(SwingReportViewer)
  * com.inet.viewer.ViewerContext
    * showUrl="../../String-Properties"
* Methoden und Konstanten, die ab Version 9 veraltet sind
  * com.inet.viewer.ReportViewer
    * setCustomPromptEditor(String, CustomPromptEditor)

### i-net DesignerXML
* Willkommensseite hinzugefügt.
* Schritt-für-Schritt-Tutorials hinzugefügt.
* **Standardwerte für Schriftarten etc. unterstützt** - Es ist nun möglich, Standardwerte für die Formatierungseigenschaften für neu erstellte Elemente in i-net DesignerXML festzulegen.
* Berichtsvorschau im Datei-Öffnen-Dialog hinzugefügt.
* **Fortschrittsbalken hinzugefügt.** - Der i-net DesignerXML zeigt nun einen Fortschrittsbalken an, wenn ein Prozess einige Zeit in Anspruch nimmt, z. B. beim Versuch einer Datenbankverbindung oder beim Laden eines großen Berichts. Dieser Prozess kann auch jederzeit abgebrochen werden. Dies behebt das alte Verhalten, bei dem der Designer blockiert wurde, bis die Prozesse beendet waren.
* Der Feldbrowser unterstützt jetzt das Duplizieren und Umbenennen von Formel-, Eingabeaufforderungs-, Sql-Ausdrucks- und Statistikfeldern.
* Es ist jetzt möglich, eine Summe in anderen Summen zu verwenden. Beachten Sie, dass die Summen in der richtigen Reihenfolge erstellt werden müssen.
* Beim Öffnen einer Eigenschaftsformel werden mögliche Konstanten, die für die Formel zurückgegeben werden können, als Kommentar im Formeldialog angezeigt.
* **Diagramm-Eigenschaften: ** - Es ist jetzt möglich, Sekunden im Kalender zu setzen.
* **Formel-Editor: ** - Die Markierung von fehlerhaften Teilen der Formel wurde verbessert.
* **Teilberichtsverknüpfungen: ** - Es ist jetzt möglich, die Breite des Baums im Dialogfeld "Verknüpfungen" zu ändern.
* **Parametereigenschaften: ** - Es gibt 3 neue Tastenkombinationen im Parameterfeld-Eigenschaften-Dialog des Designers: Strg+N erstellt eine neue Eingabeaufforderung, Alt+Up verschiebt eine Eingabeaufforderung innerhalb der Liste nach oben, Alt+Down verschiebt eine Eingabeaufforderung innerhalb der Liste nach unten.
* Der Designer verfügt nun über ein internes Backup-System, das Berichte beim Speichern überschreibt, um Datenverluste zu vermeiden, wenn das Speichern eines Berichts nicht korrekt abgeschlossen wird (Build 9.0.130).
* **Dokumenteneigenschaften:** - Eigenschaft "Report Locale" zu den Dokumenteigenschaften hinzugefügt (Build 9.0.170).
* Neuer Befehlszeilenparameter "-new" hinzugefügt, um den i-net DesignerXML mit einem neuen Bericht zu starten
* Unter Mac OS X wird für Menüpunkte und Funktionen nun die CMD-Taste anstelle der STRG- oder CTRL-Taste verwendet (Build 9.0.170).
* Startskript "startDesigner.command" für Mac OS X hinzugefügt (Build 9.0.170).

#### API-Änderungen
* Methoden hinzugefügt
  * com.inet.designer.DesignerDataModel
    * loadReportFrom(Komponente, Datei)

#### Externe Bibliotheken
* Schritt-für-Schritt-Tutorial (SBSTutorial.jar) Version 1.0 hinzugefügt.

### Einrichtung
* Verbesserte Auswahl des Installationstyps und der Komponentenauswahl.
* ISAPI wurde durch ASP.NET ersetzt.
* Registrierung der Dateierweiterungen ".rpt" und ".jra" während des Setups möglich.

[bugfixes]
### i-net Crystal-Clear-Runtime
* ArrayIndexOutOfBoundsException occurred if report was designed on Informix stored procedure.
* Lines and boxes spanning multiple sections with enabled "Extends to Bottom of Page" were sometimes not displayed correctly.
* Error message "The page "x" is out of range (y)" occurred under certain conditions.
* The "null behavior" of formulas was incorrectly read from Crystal Reports templates.
* A rare NullPointerException could occur internally when opening the scheduler Servlet on a Tomcat 5.5 system.
* A NullPointerException occurred when a report was incorrectly saved with two summary fields having the same name.
* There were line break issues when prompts were used as field parts and were directly connected to text parts with no spaces in between.
* XLS export: Property "firstgroupassheets" has not worked correctly (no new sheets were created for the group instances) if multiple section has been suppressed in the report.
* In sub reports without can grow there were overlaps and the border of the sub report has been overwritten.
* The size of sub reports is not reduced if the designed space is larger than needed.
* Detail section with enabled "Underlay Following" slipped behind group footer.
* On Unix/Linux systems, a BackingStoreException could be fired every 30 seconds if write privileges were not available for the user or system preferences.
* The ToText function used the server locale instead of the client locale for creating a string for date ranges. It now uses the client locale.
* JRA/JAR export did not work with report URL parameter "init".
* The method "Datasource.getDatabase()" could lead to a "Connection leak", meaning Connection objects were created but not closed. This could lead to timeouts and other problems later on.
* It was possible to call engine.getDatabaseTables() before setReportFile was called.
* Under some circumstances, parameter fields which were only used in the Record Selection Formula were not requested from the user when running the report.
* NumberFormatException while reading report file occurred during thread problems (fixed in build 9.0.113).
* IllegalArgumentException occurred while opening report file after parameter field type has changed (fixed in build 9.0.120).
* Because of an exception occurred while reading sproc parameter values for a store procedure (e.g. on Informix) the value for some stored procedure parameters was null (fixed in build 9.0.121).
* Cascading parameter fields were incorrectly read from reports saved since version 9.0 (fixed in build 9.0.130).
* ReportBridge and PHP sample has not worked correctly with current i-net Crystal-Clear version
* Formula function "lookslike" does not detect string "bcdbcde" by the pattern "bcd *?" (fixed in build 9.0.170).
* JavaVM crashed on a Windows XP machine if Java 6 was used and after opening a document (e.g. PDF file) or browsing to an URL ="../../fixed-in-build-9.0.170".
* Under some circumstances, parameter fields which were only used in SQL expression fields were not requested from the user when running the report.
* ReportReaderNet has created corrupt rpt files with diagonal lines, invalid xml etc. (fixed in build 9.0.170).
* An report error occurred if a formula contains very long integer numbers. The formula parser is now able to read very long integer numbers (fixed in build 9.0.175).

### i-net Crystal-Clear - Java Viewer
* Hairlines in reports designed with Crystal Reports were incorrectly interpreted, also double hairlines were displayed as a single line only.
* Selecting text and copying snapshots in the viewer had performance issues in Java 1.6 which were fixed by no longer using XOR rectangles but rather transparent areas.
* On a dual monitor system, the calendar in the prompt dialog would show on the edge of the left monitor if the viewer was showing on the right monitor. Instead it is now shown at the correct spot.
* When using ASP with the Java Viewer, the report viewer would send a request that ASP would have a problem with (of the form http://host/?&report=...").
* The cursor for selecting text in the viewer was slightly off center (fixed in build 9.0.130).
* If a viewer tab was to be closed by clicking on the tab's "X" with the middle mouse button, an IndexOutOfBoundsException occurred internally and was written to the log (fixed in build 9.0.130).
* BMP, GIF, JPG and PNG export was not possible if Java report viewer was used as applet (fixed in build 9.0.130).

### i-net DesignerXML
* Hairline was not displayed in Design view.
* Simply opening up the Record Selection Formula Dialog caused the database to be unnecessarily contacted, which could take a while especially if the database connection was slow.
* Visual Database Wizard:
  * An invalid connection could lead to the designer hanging for 20+ seconds after right-clicking on a table.
  * The context menu commands "Edit SQL" and "Show SQL" were not displayed for SQL command table sources.
  * If a manual SQL statement was provided which ended with a semicolon, an error occurred which has now been fixed: unnecessary semicolons at the end of manual SQL statements are now ignored (fixed in build 9.0.130).
* Parameter Properties: The OK button was grayed out when two prompts had the same name, but was not activated again after making the names unique again.
* In rare cases in reports using summary functions in formulas, required summary fields could be removed from the report, leading to errors and blank fields.
* Opening a JRA file in the designer could lead to an unhandled NullPointerException (fixed in build 9.0.130).

[bugfixes:de]
### i-net Crystal-Clear-Runtime
* ArrayIndexOutOfBoundsException trat auf, wenn der Bericht auf einer gespeicherten Informix-Prozedur beruhte.
* Zeilen und Kästen, die sich über mehrere Abschnitte erstrecken und bei denen die Option "Erstreckt sich bis zum unteren Rand der Seite" aktiviert ist, wurden manchmal nicht korrekt angezeigt.
* Die Fehlermeldung "Die Seite "x" liegt außerhalb des Bereichs (y)" trat unter bestimmten Bedingungen auf.
* Das "Null-Verhalten" von Formeln wurde von Crystal Reports-Vorlagen nicht korrekt gelesen.
* Eine seltene NullPointerException konnte intern auftreten, wenn das Scheduler Servlet auf einem Tomcat 5.5 System geöffnet wurde.
* Eine NullPointerException trat auf, wenn ein Bericht fälschlicherweise mit zwei gleichnamigen Statistikfeldern gespeichert wurde.
* Es gab Probleme mit dem Zeilenumbruch, wenn Eingabeaufforderungen als Feldteile verwendet wurden und direkt mit Textteilen verbunden waren, ohne dass Leerzeichen dazwischen lagen.
* XLS-Export: Die Eigenschaft "firstgroupassheets" hat nicht korrekt funktioniert (es wurden keine neuen Blätter für die Gruppeninstanzen erstellt), wenn im Bericht mehrere Abschnitte unterdrückt wurden.
* In Unterberichten ohne Can-Grow gab es Überlappungen und der Rand des Unterberichts wurde überschrieben.
* Die Größe von Unterberichten wird nicht reduziert, wenn der gestaltete Platz größer ist als benötigt.
* Detailbereich mit aktiviertem "Underlay Following" rutschte hinter die Gruppenfußzeile.
* Auf Unix/Linux-Systemen konnte alle 30 Sekunden eine BackingStoreException ausgelöst werden, wenn für den Benutzer oder die Systemeinstellungen keine Schreibrechte verfügbar waren.
* Die Funktion ToText verwendete das Servergebietsschema anstelle des Clientgebietsschemas für die Erstellung einer Zeichenfolge für Datumsbereiche. Sie verwendet jetzt das Client-Gebietsschema.
* Der JRA/JAR-Export funktionierte nicht mit dem Report-URL-Parameter "init".
* Die Methode "Datasource.getDatabase()" konnte zu einem "Verbindungsleck" führen, d. h. Verbindungsobjekte wurden erstellt, aber nicht geschlossen. Dies konnte später zu Timeouts und anderen Problemen führen.
* Es war möglich, engine.getDatabaseTables() aufzurufen, bevor setReportFile aufgerufen wurde.
* Unter bestimmten Umständen wurden Parameterfelder, die nur in der Datensatzauswahlformel verwendet wurden, beim Ausführen des Berichts nicht vom Benutzer angefordert.
* NumberFormatException beim Lesen der Berichtsdatei trat bei Thread-Problemen auf (behoben in Build 9.0.113).
* IllegalArgumentException trat beim Öffnen der Berichtsdatei auf, nachdem der Typ des Parameterfeldes geändert wurde (behoben in Build 9.0.120).
* Aufgrund einer Ausnahme beim Lesen von Sproc-Parameterwerten für eine Stored Procedure (z.B. auf Informix) war der Wert für einige Stored-Procedure-Parameter null (behoben in Build 9.0.121).
* Kaskadierende Parameterfelder wurden aus Berichten, die seit Version 9.0 gespeichert wurden, falsch gelesen (behoben in Build 9.0.130).
* ReportBridge und PHP-Beispiel haben mit der aktuellen i-net Crystal-Clear-Version nicht korrekt funktioniert
* Die Formelfunktion "lookslike" erkennt den String "bcdbcde" nicht nach dem Muster "bcd *?" (behoben in Build 9.0.170).
* JavaVM stürzte auf einem Windows XP-Rechner ab, wenn Java 6 verwendet wurde und ein Dokument (z.B. PDF-Datei) geöffnet oder eine URL ="../../fixed-in-build-9.0.170" aufgerufen wurde.
* Unter bestimmten Umständen wurden Parameterfelder, die nur in SQL-Ausdruckfeldern verwendet wurden, beim Ausführen des Berichts nicht vom Benutzer abgefragt.
* ReportReaderNet hat korrupte rpt-Dateien mit diagonalen Linien, ungültigen xml etc. erstellt (behoben in Build 9.0.170).
* Ein Berichtsfehler trat auf, wenn eine Formel sehr lange Integer-Zahlen enthielt. Der Formel-Parser ist nun in der Lage, sehr lange Integer-Zahlen zu lesen (behoben in Build 9.0.175).

### i-net Crystal-Clear - Java Viewer
* Haarlinien in Berichten, die mit Crystal Reports erstellt wurden, wurden falsch interpretiert, auch doppelte Haarlinien wurden nur als eine Linie dargestellt.
* Beim Markieren von Text und Kopieren von Snapshots im Viewer gab es in Java 1.6 Performance-Probleme, die dadurch behoben wurden, dass keine XOR-Rechtecke mehr verwendet wurden, sondern transparente Bereiche.
* Auf einem Dual-Monitor-System wurde der Kalender im Eingabeaufforderungsdialog am Rand des linken Monitors angezeigt, wenn der Viewer auf dem rechten Monitor angezeigt wurde. Stattdessen wird er jetzt an der richtigen Stelle angezeigt.
* Bei der Verwendung von ASP mit dem Java Viewer sendete der Report-Viewer eine Anfrage, mit der ASP ein Problem hatte (in der Form http://host/?&report=...").
* Der Cursor zum Auswählen von Text im Viewer war leicht dezentriert (behoben in Build 9.0.130).
* Wenn eine Viewer-Registerkarte durch Klicken auf das "X" der Registerkarte mit der mittleren Maustaste geschlossen werden sollte, trat intern eine IndexOutOfBoundsException auf, die in das Protokoll geschrieben wurde (behoben in Build 9.0.130).
* BMP-, GIF-, JPG- und PNG-Export war nicht möglich, wenn der Java Report Viewer als Applet verwendet wurde (behoben in Build 9.0.130).

### i-net DesignerXML
* Die Haarlinie wurde in der Entwurfsansicht nicht angezeigt.
* Das einfache Öffnen des Dialogs für die Datensatzauswahlformel führte zu einer unnötigen Kontaktaufnahme mit der Datenbank, was insbesondere bei langsamen Datenbankverbindungen eine Weile dauern konnte.
* Visueller Datenbank-Assistent:
  * Eine ungültige Verbindung konnte dazu führen, dass der Designer nach einem Rechtsklick auf eine Tabelle für mehr als 20 Sekunden hängen blieb.
  * Die Kontextmenübefehle "SQL bearbeiten" und "SQL anzeigen" wurden für SQL-Befehlstabellenquellen nicht angezeigt.
  * Wenn eine manuelle SQL-Anweisung angegeben wurde, die mit einem Semikolon endete, trat ein Fehler auf, der jetzt behoben wurde: Unnötige Semikolons am Ende von manuellen SQL-Anweisungen werden jetzt ignoriert (behoben in Build 9.0.130).
* Parameter-Eigenschaften: Die OK-Schaltfläche war ausgegraut, wenn zwei Eingabeaufforderungen denselben Namen hatten, wurde aber nicht wieder aktiviert, nachdem die Namen wieder eindeutig gemacht wurden.
* In seltenen Fällen konnten in Berichten, die Zusammenfassungsfunktionen in Formeln verwenden, erforderliche Zusammenfassungsfelder aus dem Bericht entfernt werden, was zu Fehlern und leeren Feldern führte.
* Das Öffnen einer JRA-Datei im Designer konnte zu einer unbehandelten NullPointerException führen (behoben in Build 9.0.130).

[security]

[security:de]
